do
	
	local oldModBlueprints = ModBlueprints

	function ModBlueprints(all_bps)
		oldModBlueprints(all_bps)

		local a, t, n = 0, 0, 0		--	number of weapons, total RateOfFire.
		local e = 2.7182818284590452353602874713527 -- 1.61803399		--	exponent base, higher means more exascerbation.
		local gain = 0
		local bias = 1.2247448713915890490986420373529
				
		for id, bp in all_bps.Unit do

			if bp.Weapon then

				for ik, wep in bp.Weapon do

					if wep.RateOfFire then
						t = t + (wep.RateOfFire or 0)
						n = n + 1
					end

				end	--	bp.Weapon loop

			end	--	if bp.Weapon

		end	--	all_bps.Unit loop
		
		-- artificially shift the average using the bias.
		a = bias * t / n
		LOG("*BM: average RateOfFire = " .. a)
		
		for id, bp in all_bps.Unit do
		
			if bp.Weapon then

				for ik, wep in bp.Weapon do

					if wep.RateOfFire then

						gain = math.pow(e, wep.RateOfFire / a - 1)
--						gain = math.sqrt(wep.RateOfFire / a)

						if gain * wep.RateOfFire > 10 then
							gain = 10 / wep.RateOfFire
						end

						wep.RateOfFire = wep.RateOfFire * gain
						wep.Damage = wep.Damage / gain
					end

				end	--	bp.Weapon loop

			end	--	if bp.Weapon

		end	--	all_bps.Unit loop
		
	end

end